﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net;
using System.Net.Mail;

namespace CentralMudances
{
    public class EMail
    {
        List<Servei.Configuracio> configuracio;
        Servei.ServeiMudancesClient client = new Servei.ServeiMudancesClient();

        private void LoadConfig()
        {
            configuracio = client.getConfiguracio().ToList();
        }
        private string GetConfigParameter(string parametre)
        {
            Servei.Configuracio cnf = (from i in configuracio
                                       where i.propietat == parametre
                                       select i).FirstOrDefault();

            if (cnf != null)
                return cnf.valor;
            else
                return "";
        }
        public bool SendEmail(string emailDesti, string subject, string body, string fileAttached)
        {
            try
            {
                MailMessage mail = new MailMessage();
                SmtpClient SmtpServer = new SmtpClient(GetConfigParameter("emailServer"));
                mail.From = new MailAddress(GetConfigParameter("EMail"));
                mail.To.Add(emailDesti);
                mail.Subject = subject;
                mail.Body = body;

                System.Net.Mail.Attachment attachment;
                attachment = new System.Net.Mail.Attachment(fileAttached);
                mail.Attachments.Add(attachment);

                SmtpServer.Credentials = new System.Net.NetworkCredential(GetConfigParameter("emailUser"), GetConfigParameter("emailPassword"));
                SmtpServer.Send(mail);
            }
            catch 
            {
                return false;
            }
            return true;
        }
    }
}
