﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Collections.Generic;

namespace CentralMudances.Finestres
{
    /// <summary>
    /// Lógica de interacción para CercaElements.xaml
    /// </summary>
    public partial class CercaElements : Window
    {
        private Dictionary<int, string> valors;
        
        public int selectedValue = -1;

        public CercaElements(string _descripcio, Dictionary<int, string> _valors)
        {
            InitializeComponent();
            
            this.Title = "Cerca de " + _descripcio;
            valors = _valors;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            this.gCerca.ItemsSource = valors;
        }

        private void gCerca_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (e.AddedItems.Count == 0)
                return;

            selectedValue = ((KeyValuePair<int, string>)e.AddedItems[0]).Key;
        }

        private void bCancel_Click(object sender, RoutedEventArgs e)
        {
            this.selectedValue = -1;
            this.Close();
        }

        private void bOK_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void tFiltre_TextChanged(object sender, TextChangedEventArgs e)
        {
            var res = from i in valors
                      where i.Value.Contains(tFiltre.Text)
                      select i;

            gCerca.ItemsSource = res;
        }

        
    }
}
