﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace CentralMudances.Finestres
{
    /// <summary>
    /// Lógica de interacción para FiltresPressupostos.xaml
    /// </summary>
    public partial class FiltresPressupostos : Window
    {
        public enum TipusFiltre
        {
            usuari,
            dates,
            factura,
            acceptat
        }
        public TipusFiltre filtreSeleccionat = TipusFiltre.usuari;
        public DateTime dataIni;
        public DateTime dataFin;
        public bool CertFals;

        public FiltresPressupostos()
        {
            InitializeComponent();
        }

        private void rbTotes_Checked(object sender, RoutedEventArgs e)
        {
            if (tDataIni == null)
                return;
            
            tDataIni.IsEnabled = false;
            tDataFin.IsEnabled = false;
            ckAcceptat.IsEnabled = false;
            ckFacturat.IsEnabled = false;
        }

        private void rbData_Checked(object sender, RoutedEventArgs e)
        {
            if (tDataIni.SelectedDate == null || tDataFin.SelectedDate == null)
            {
                tDataIni.SelectedDate = DateTime.Today.AddDays(-7);
                tDataFin.SelectedDate = DateTime.Today;
            }

            tDataIni.IsEnabled = true;
            tDataFin.IsEnabled = true;
            ckAcceptat.IsEnabled = false;
            ckFacturat.IsEnabled = false;
        }

        private void rbAcceptat_Checked(object sender, RoutedEventArgs e)
        {
            tDataIni.IsEnabled = false;
            tDataFin.IsEnabled = false;
            ckAcceptat.IsEnabled = true;
            ckFacturat.IsEnabled = false;
        }

        private void rbFacturat_Checked(object sender, RoutedEventArgs e)
        {
            tDataIni.IsEnabled = false;
            tDataFin.IsEnabled = false;
            ckAcceptat.IsEnabled = false;
            ckFacturat.IsEnabled = true;
        }

        private void bCancela_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void bFiltra_Click(object sender, RoutedEventArgs e)
        {
            if (rbTotes.IsChecked.Value)
            {
                filtreSeleccionat = TipusFiltre.usuari;
            }
            else if (rbData.IsChecked.Value)
            {
                if (tDataIni.SelectedDate.Value > tDataFin.SelectedDate.Value)
                {
                    MessageBox.Show("La data inicial no pot ser superior a la final.", "Error");
                    return;
                }

                filtreSeleccionat = TipusFiltre.dates;
                dataIni = tDataIni.SelectedDate.Value;
                dataFin = tDataFin.SelectedDate.Value;
            }
            else if (rbFacturat.IsChecked.Value)
            {
                filtreSeleccionat = TipusFiltre.factura;
                CertFals = ckFacturat.IsChecked.Value;
            }
            else if (rbAcceptat.IsChecked.Value)
            {
                filtreSeleccionat = TipusFiltre.acceptat;
                CertFals = ckFacturat.IsChecked.Value;
            }

            this.Hide();
        }
    }
}
