﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace CentralMudances
{
    /// <summary>
    /// Lógica de interacción para Login.xaml
    /// </summary>
    public partial class Login : Window
    {
        Servei.ServeiMudancesClient client = new Servei.ServeiMudancesClient();

        public Login()
        {
            InitializeComponent();

            double screenWidth = System.Windows.SystemParameters.PrimaryScreenWidth;
            double screenHeight = System.Windows.SystemParameters.PrimaryScreenHeight;
            double windowWidth = this.Width;
            double windowHeight = this.Height;
            this.Left = (screenWidth / 2) - (windowWidth / 2);
            this.Top = (screenHeight / 2) - (windowHeight / 2);
        }

        private void bAcceptar_Click(object sender, RoutedEventArgs e)
        {
            var te = client.validaUsuari(txUsuari.Text, txPassword.Password);
            if (te != null)
            {
                Principal frmPrincipal = new Principal(te);
                frmPrincipal.Show();
                this.Close();
            }
            else
            {
                MessageBox.Show("Usuari o contrassenya incorrectes.");
                this.BuidaFormulari();
            }
        }

        private void bCancelar_Click(object sender, RoutedEventArgs e)
        {
            this.BuidaFormulari();
            this.Close();
        }
        private void BuidaFormulari()
        {
            txUsuari.Text = "";
            txPassword.Password = "";
        }

    }
}
