﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Mudances_WCF
{
    public class ClientsDAO
    {
        MudancesEntities bdMudances;

        /// <summary>
        /// Constructor de la classe
        /// </summary>
        public ClientsDAO()
        {
            bdMudances = new MudancesEntities();
        }

        /// <summary>
        /// Retorna la llista de tots els clients creats a la base de dades.
        /// </summary>
        /// <returns>Un objecte IEnumerable amb tots el clients creats.</returns>
        public List<Client> getClients()
        {
            List<Client> clients = new List<Client>();
            try
            {
                IEnumerable<clientSet> temp = from i in bdMudances.clientSet
                                              select i;

                foreach (clientSet cli in temp)
                {
                    clients.Add(new Client(cli));
                }
            }
            catch
            { /* Do nothign */ }

            return clients;
        }

        /// <summary>
        /// Funció encarregada de crear un nou client a la base de dades
        /// </summary>
        /// <param name="cli">Instància de l'objecte que es crearà a la base de dades</param>
        /// <returns>Verdader si s'ha pogut crear l'objecte, Fals en cas contrari</returns>
        public bool addClient(Client cli)
        {
            try
            {
                clientSet newClient = new clientSet();
                this.PocoToDAO(ref newClient, ref cli);
                bdMudances.clientSet.Add(newClient);
                bdMudances.SaveChanges();
            }
            catch
            {
                return false;
            }

            return true;
        }

        /// <summary>
        /// Funció encarregada d'actualitzar les dades d'un client a la base de dades
        /// </summary>
        /// <param name="cli">Instància de l'objecte modificat</param>
        /// <returns>Verdader si s'ha pogut actualizar l'objecte, Fals en cas contrari</returns>
        public bool updateClient(Client cli)
        {
            try
            {
                clientSet old = (from i in bdMudances.clientSet
                                 where i.Id == cli.Id
                                 select i).First();

                this.PocoToDAO(ref old, ref cli);
                
                bdMudances.SaveChanges();
            }
            catch
            {
                return false;
            }

            return true;
        }

        /// <summary>
        /// Funció encarregada de la transformació d'una entitat POCO a una del tipus DAO.
        /// </summary>
        private void PocoToDAO(ref clientSet DAO, ref Client POCO)
        {
            DAO.nom = POCO.nom;
            DAO.cognoms = POCO.cognoms;
            DAO.dni = POCO.dni;
            DAO.poblacio = POCO.poblacio;
            DAO.provincia = POCO.provincia;
            DAO.telefon = POCO.telefon;
            DAO.mobil = POCO.mobil;
            DAO.fax = POCO.fax;
            DAO.adreça = POCO.adreça;
            DAO.baixa = POCO.baixa;
            DAO.cp = POCO.cp;
            DAO.email = POCO.email;
        }
    }
}