﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;

namespace Mudances_WCF
{
    /// <summary>
    /// Interface que el servei WCF implementa.
    /// </summary>
    [ServiceContract]
    public interface IServeiMudances
    {
        #region "Operaris"
        [OperationContract]
        List<Operari> getOperaris();

        [OperationContract]
        bool addOperari(Operari op);

        [OperationContract]
        bool updateOperari(Operari op);
        #endregion

        #region "Vehicles"
        [OperationContract]
        List<Vehicle> getVehicles();
        
        [OperationContract]
        bool addVehicle(Vehicle veh);
        
        [OperationContract]
        bool updateVehicle(Vehicle veh);
        #endregion

        #region"Clients"
        [OperationContract]
        List<Client> getClients();

        [OperationContract]
        bool addClient(Client cli);

        [OperationContract]
        bool updateClient(Client cli);
        #endregion

        #region "Usuaris"
        [OperationContract]
        List<Usuari> getUsers();

        [OperationContract]
        bool addUser(Usuari user);

        [OperationContract]
        bool updateUser(Usuari user);

        [OperationContract]
        Usuari validaUsuari(string name, string pwd);
        #endregion

        #region "Pressupostos"
        [OperationContract]
        List<Pressupost> getPressupostos();

        [OperationContract]
        List<Pressupost> getPressupostosByUser(Usuari user);

        [OperationContract]
        List<Pressupost> getPressupostosByDate(DateTime dIni, DateTime dFin);

        [OperationContract]
        List<Pressupost> getPressupostosByEstat(bool acceptat);

        [OperationContract]
        List<Pressupost> getPressupostosByFacturat(bool facturat);

        [OperationContract]
        Pressupost getPressupostById(int id);

        [OperationContract]
        bool addPressupost(Pressupost pressupost);

        [OperationContract]
        bool updatePressupost(Pressupost pressupost);

        [OperationContract]
        bool facturaPressupost(int pressupostId);
        #endregion

        #region "Configuració"
        [OperationContract]
        List<Configuracio> getConfiguracio();

        [OperationContract]
        bool updateConfiguracio(List<Configuracio> configuracio);
        #endregion
    }

}
