﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Runtime.Serialization;

namespace Mudances_WCF
{
    /// <summary>
    /// Classe que es fa servir per a la comunicació a través del servei de WCF.
    /// </summary>
    [DataContract]
    public class LiniaPressupost
    {
        /// <summary>
        /// Constructor de la classe.
        /// </summary>
        public LiniaPressupost()
        {
            imatges = new List<Imatge>();
        }
        /// <summary>
        /// Constructor de la classe que rep com a paràmetre el seu objecte corresponent a la capa DAO.
        /// S'encarrega d'inicialitzar els valors en funció de l'objecte rebut.
        /// </summary>
        public LiniaPressupost(linia_pressupostSet dao)
        {
            imatges = new List<Imatge>();

            this.Id = dao.Id;
            this.article = dao.article;
            this.comentaris = dao.comentaris;
            this.transportat = dao.transportat;
            this.temps_dedicat = dao.temps_dedicat;
            this.preu = dao.preu;

            if (dao.imatgesSet.Count > 0)
            {
                foreach (imatgesSet imatge in dao.imatgesSet)
                {
                    imatges.Add(new Imatge(imatge));
                }
            }
        }

        [DataMember]
        public int Id;
        [DataMember]
        public string article;
        [DataMember]
        public string comentaris;
        [DataMember]
        public bool transportat;
        [DataMember]
        public int temps_dedicat;
        [DataMember]
        public decimal preu;
        
        [DataMember]
        public List<Imatge> imatges;
    }
}