﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Runtime.Serialization;


namespace Mudances_WCF
{
    /// <summary>
    /// Classe que es fa servir per a la comunicació a través del servei de WCF.
    /// </summary>
    [DataContract]    
    public class Usuari
    {
        /// <summary>
        /// Constructor de la classe.
        /// </summary>
        public Usuari()
        { }
        /// <summary>
        /// Constructor de la classe que rep com a paràmetre el seu objecte corresponent a la capa DAO.
        /// S'encarrega d'inicialitzar els valors en funció de l'objecte rebut.
        /// </summary>
        public Usuari(usuariSet dao)
        {
            this.Id = dao.Id;
            this.administrador = dao.administrador;
            this.baixa = dao.baixa;
            this.central = dao.central;
            this.nom = dao.nom;
            this.password = dao.password;
            this.wp8 = dao.wp8;
        }

        [DataMember]
        public int Id;
        [DataMember]
        public bool administrador;
        [DataMember]
        public bool baixa;
        [DataMember]
        public bool central;
        [DataMember]
        public string nom;
        [DataMember]
        public string password;
        [DataMember]
        public bool wp8;
    }
}