﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;

namespace Mudances_WCF
{
    // NOTA: puede usar el comando "Rename" del menú "Refactorizar" para cambiar el nombre de clase "Service1" en el código, en svc y en el archivo de configuración.
    // NOTE: para iniciar el Cliente de prueba WCF para probar este servicio, seleccione Service1.svc o Service1.svc.cs en el Explorador de soluciones e inicie la depuración.
    public class ServeiMudances : IServeiMudances
    {
        #region "Operaris"

        /// <summary>
        /// Funció encarregada de retornar una llista amb tots el operaris definits a la base de dades.
        /// </summary>
        public List<Operari> getOperaris()
        {
            OperarisDAO operaris = new OperarisDAO();
            return operaris.getOperaris();
        }

        /// <summary>
        /// Funció encarregada d'afegir a la base de dades l'operari passat com a paràmetre.
        /// </summary>
        public bool addOperari(Operari op)
        {
            OperarisDAO operaris = new OperarisDAO();
            return operaris.addOperari(op);
        }

        /// <summary>
        /// Funció encarregada d'actualitzar a la base de dades l'operari passat com a paràmetre.
        /// </summary>
        public bool updateOperari(Operari op)
        {
            OperarisDAO operaris = new OperarisDAO();
            return operaris.updateOperari(op);
        }
        #endregion

        #region "Vehicles"
        
        /// <summary>
        /// Funció encarregada de retornar una llista amb tots els vehicles definits a la base de dades.
        /// </summary>
        public List<Vehicle> getVehicles()
        {
            VehiclesDAO vehicles = new VehiclesDAO();
            return vehicles.getVehicles();
        }

        /// <summary>
        /// Funció encarregada d'afegir a la base de dades el vehicle passat com a paràmetre.
        /// </summary>
        public bool addVehicle(Vehicle veh)
        {
            VehiclesDAO vehicles = new VehiclesDAO();
            return vehicles.addVehicle(veh);
        }

        /// <summary>
        /// Funció encarregada d'actualitzar a la base de dades el vehicle passat com a paràmetre.
        /// </summary>
        public bool updateVehicle(Vehicle veh)
        {
            VehiclesDAO vehicles = new VehiclesDAO();
            return vehicles.updateVehicle(veh);
        }
        #endregion

        #region "Clients"

        /// <summary>
        /// Funció encarregada de retornar una llista amb tots els clients definits a la base de dades.
        /// </summary>
        public List<Client> getClients()
        {
            ClientsDAO clients = new ClientsDAO();
            return clients.getClients();
        }

        /// <summary>
        /// Funció encarregada d'afegir a la base de dades el client passat com a paràmetre.
        /// </summary>
        public bool addClient(Client cli)
        {
            ClientsDAO clients = new ClientsDAO();
            return clients.addClient(cli);
        }

        /// <summary>
        /// Funció encarregada d'actualitzar a la base de dades el client passat com a paràmetre.
        /// </summary>
        public bool updateClient(Client cli)
        {
            ClientsDAO clients = new ClientsDAO();
            return clients.updateClient(cli);
        }
        #endregion

        #region "Usuaris"

        /// <summary>
        /// Funció encarregada de retornar una llista amb tots els usuaris definits a la base de dades.
        /// </summary>
        public List<Usuari> getUsers()
        {
            UsuarisDAO usuaris = new UsuarisDAO();
            return usuaris.getUsers();
        }

        /// <summary>
        /// Funció encarregada d'afegir a la base de dades l'usuari passat com a paràmetre.
        /// </summary>
        public bool addUser(Usuari user)
        {
            UsuarisDAO usuaris = new UsuarisDAO();
            return usuaris.addUser(user);
        }

        /// <summary>
        /// Funció encarregada d'actualitzar a la base de dades l'usuari passat com a paràmetre.
        /// </summary>
        public bool updateUser(Usuari user)
        {
            UsuarisDAO usuaris = new UsuarisDAO();
            return usuaris.updateUser(user);
        }

        /// <summary>
        /// Funció encarregada de validar l'usuari en funció del seu usuari i el seu password.
        /// Si es correcte, retorna l'objecte corresponent. En cas contrari retorna NULL.
        /// </summary>
        public Usuari validaUsuari(string name, string pwd)
        {
            UsuarisDAO usuaris = new UsuarisDAO();
            return usuaris.validaUsuari(name, pwd);
        }
        #endregion

        #region "Pressupostos"

        /// <summary>
        /// Funció encarregada de retornar una llista amb tots els pressupostos definits a la base de dades.
        /// </summary>
        public List<Pressupost> getPressupostos()
        {
            PressupostosDAO pressupostos = new PressupostosDAO();
            return pressupostos.getPressupostos();
        }

        /// <summary>
        /// Funció encarregada de retornar una llista amb tots els pressupostos associats a l'usuari passat
        /// com a paràmetre.
        /// </summary>
        public List<Pressupost> getPressupostosByUser(Usuari user)
        {
            PressupostosDAO pressupostos = new PressupostosDAO();
            return pressupostos.getPressupostos(user);
        }

        /// <summary>
        /// Funció encarregada de retornar una llista amb tots els pressupostos creats entre les dates informades
        /// als paràmetres.
        /// </summary>
        public List<Pressupost> getPressupostosByDate(DateTime dIni, DateTime dFin)
        {
            PressupostosDAO pressupostos = new PressupostosDAO();
            return pressupostos.getPressupostos(dIni, dFin);
        }

        /// <summary>
        /// Funció encarregada de retornar una llista amb tots els pressupostos en funció de si estàn o no
        /// acceptats.
        /// </summary>
        public List<Pressupost> getPressupostosByEstat(bool acceptat)
        {
            PressupostosDAO pressupostos = new PressupostosDAO();
            return pressupostos.getPressupostosByEstat(acceptat);
        }

        /// <summary>
        /// Funció encarregada de retornar una llista amb tots els pressupostos en funció de si estan o no facturats.
        /// </summary>
        public List<Pressupost> getPressupostosByFacturat(bool facturat)
        {
            PressupostosDAO pressupostos = new PressupostosDAO();
            return pressupostos.getPressupostByFacturat(facturat);
        }

        /// <summary>
        /// Funció encarregada de retornar el pressupost corresponent a l'identificador passat.
        /// </summary>
        public Pressupost getPressupostById(int id)
        {
            PressupostosDAO pressupostos = new PressupostosDAO();
            return pressupostos.getPressupostById(id);
        }

        /// <summary>
        /// Funció encarregada d'afegir a la base de dades el pressupost passat com a paràmetre.
        /// </summary>
        public bool addPressupost(Pressupost pressupost)
        {
            PressupostosDAO pressupostos = new PressupostosDAO();
            return pressupostos.addPressupost(pressupost);
        }

        /// <summary>
        /// Funció encarregada d'actualitzar a la base de dades el pressupost passat com a paràmetre.
        /// </summary>
        public bool updatePressupost(Pressupost pressupost)
        {
            PressupostosDAO pressupostos = new PressupostosDAO();
            return pressupostos.updatePressupost(pressupost);
        }

        /// <summary>
        /// Funció encarregada de facturar el pressupost passat.
        /// </summary>
        public bool facturaPressupost(int pressupostId)
        {
            PressupostosDAO pressupostos = new PressupostosDAO();
            return pressupostos.facturaPressupost(pressupostId);
        }

        #endregion

        #region "Configuració"
        /// <summary>
        /// Funció encarregada de retornar la llista d'elements configurats a la base de dades.
        /// </summary>
        public List<Configuracio> getConfiguracio()
        {
            ConfiguracioDAO configuracio = new ConfiguracioDAO();
            return configuracio.getConfiguracio();
        }

        /// <summary>
        /// Funció encarregada d'actualitzar la configuració passada a la base de dades.
        /// </summary>
        public bool updateConfiguracio(List<Configuracio> configuracio)
        {
            try
            {
                ConfiguracioDAO configuracioDAO = new ConfiguracioDAO();
                foreach (Configuracio cnf in configuracio)
                {
                    if (cnf.Id == 0)
                    {
                        configuracioDAO.addConfiguracio(cnf);
                    }
                    else
                    {
                        configuracioDAO.updateConfiguracio(cnf);
                    }
                }
            }
            catch
            {
                return false;
            }
            return true;
        }
        #endregion

    }
}
