﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WP_DAO.BaseDades;

namespace WP_DAO.Sync
{
    /// <summary>
    /// Classe encarregada de la transformació del objectes de la base de dades local al objectes amb els
    /// que treballa el servei i l'aplicació WP8.
    /// </summary>
    public static class ConversorsBDServei
    {
        public static ServeiMudances.Usuari WP8ToServei(WP8_Usuari wUser)
        {
            ServeiMudances.Usuari sUser = new ServeiMudances.Usuari();

            sUser.Id = wUser.Id;
            sUser.administrador = wUser.administrador;
            sUser.baixa = wUser.baixa;
            sUser.central = wUser.central;
            sUser.nom = wUser.nom;
            sUser.password = wUser.password;
            sUser.wp8 = wUser.wp8;

            return sUser;
        }
        public static ServeiMudances.Vehicle WP8ToServei(WP8_Vehicle wVeh)
        {
            ServeiMudances.Vehicle sVeh = new ServeiMudances.Vehicle();
            sVeh.Id = wVeh.Id;
            sVeh.nom = wVeh.nom;
            sVeh.descripcio = wVeh.descripcio;
            sVeh.baixa = wVeh.baixa;
            return sVeh;
        }
        public static ServeiMudances.Operari WP8ToServei(WP8_Operari wOp)
        {
            ServeiMudances.Operari sOp = new ServeiMudances.Operari();
            sOp.Id = wOp.Id; ;
            sOp.nom = wOp.nom;
            sOp.comentaris = wOp.comentaris;
            sOp.baixa = wOp.baixa;
            return sOp;
        }
        public static ServeiMudances.Client WP8ToServei(WP8_Client wCli)
        {
            ServeiMudances.Client sCli = new ServeiMudances.Client();
            sCli.Id =wCli.Id;
            sCli.nom =wCli.nom;
            sCli.cognoms =wCli.cognoms;
            sCli.dni =wCli.dni;
            sCli.poblacio =wCli.poblacio;
            sCli.provincia =wCli.provincia;
            sCli.telefon =wCli.telefon;
            sCli.mobil =wCli.mobil;
            sCli.fax =wCli.fax;
            sCli.adreça =wCli.adreça;
            sCli.baixa =wCli.baixa;
            sCli.cp =wCli.cp;
            sCli.email =wCli.email;
            return sCli;
        }
        public static ServeiMudances.Imatge WP8ToServei(WP8_Imatge wImg)
        {
            ServeiMudances.Imatge sImg = new ServeiMudances.Imatge();
            sImg.Id = wImg.Id;
            sImg.imatge = Convert.FromBase64String(wImg.imatge);
            return sImg;
        }
        public static ServeiMudances.LiniaPressupost WP8ToServei(WP8_LiniaPressupost wLin)
        {
            ServeiMudances.LiniaPressupost sLin = new ServeiMudances.LiniaPressupost();

            sLin.Id = wLin.Id;
            sLin.article = wLin.article;
            sLin.comentaris = wLin.comentaris;
            sLin.transportat = wLin.transportat;
            sLin.temps_dedicat = wLin.temps_dedicat;
            sLin.preu = wLin.preu;
            return sLin;
        }
        public static ServeiMudances.Pressupost WP8ToServei(WP8_Pressupost wPre)
        {
            BaseDades.Main bd = new BaseDades.Main();

            ServeiMudances.Pressupost sPre = new ServeiMudances.Pressupost();
            sPre.Id = wPre.Id;
            sPre.data = wPre.data;
            sPre.acceptat = wPre.acceptat;
            sPre.facturat = wPre.facturat;
            sPre.num_factura = wPre.num_factura;
            sPre.adreça_origen = wPre.adreça_origen;
            sPre.adreça_desti = wPre.adreça_desti;
            sPre.cp_origen = wPre.cp_origen;
            sPre.cp_desti = wPre.cp_desti;
            sPre.poblacio_origen = wPre.poblacio_origen;
            sPre.poblacio_desti = wPre.poblacio_desti;
            sPre.provincia_origen = wPre.provincia_origen;
            sPre.provincia_desti = wPre.provincia_desti;

            sPre.usuari = WP8ToServei(bd.GetUser(wPre.UsuariId));
            sPre.client = WP8ToServei(bd.GetClient(wPre.ClientId));

            sPre.vehicles = new System.Collections.ObjectModel.ObservableCollection<ServeiMudances.Vehicle>();
            foreach (WP8_Vehicle vehicle in bd.GetVehicles(wPre.Id))
            {
                sPre.vehicles.Add(WP8ToServei(vehicle));
            }

            sPre.operaris = new System.Collections.ObjectModel.ObservableCollection<ServeiMudances.Operari>();
            foreach (WP8_Operari operari in bd.GetOperaris(wPre.Id))
            {
                sPre.operaris.Add(WP8ToServei(operari));
            }
            sPre.linies = new System.Collections.ObjectModel.ObservableCollection<ServeiMudances.LiniaPressupost>();
            foreach (WP8_LiniaPressupost linia in bd.GetLinies(wPre.Id))
            {
                ServeiMudances.LiniaPressupost liniaServei = WP8ToServei(linia);
                liniaServei.imatges = new System.Collections.ObjectModel.ObservableCollection<ServeiMudances.Imatge>();
                foreach (WP8_Imatge imatge in bd.GetImatges(linia.Id))
                {
                    liniaServei.imatges.Add(WP8ToServei(imatge));
                }
                sPre.linies.Add(liniaServei);
            }

            return sPre;
        }
    }
}
