﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WP_DAO.BaseDades;

namespace WP_DAO.Sync
{
    /// <summary>
    /// Classe encarregada de la transformació del objectes rebuts pel servei als objectes que pot gestionar
    /// la base de dades local.
    /// </summary>
    public static class ConversorsServeiBD
    {
        public static WP8_Usuari ServeiToWP8(ServeiMudances.Usuari sUser)
        {
            WP8_Usuari wUser = new WP8_Usuari();

            wUser.Id = sUser.Id;
            wUser.administrador = sUser.administrador;
            wUser.baixa = sUser.baixa;
            wUser.central = sUser.central;
            wUser.nom = sUser.nom;
            wUser.password = sUser.password;
            wUser.wp8 = sUser.wp8;

            return wUser;
        }
        public static WP8_Vehicle ServeiToWP8(ServeiMudances.Vehicle sVeh)
        {
            WP8_Vehicle wVeh = new WP8_Vehicle();
            wVeh.Id = sVeh.Id;
            wVeh.nom = sVeh.nom;
            wVeh.descripcio = sVeh.descripcio;
            wVeh.baixa = sVeh.baixa;
            return wVeh;
        }
        public static WP8_Operari ServeiToWP8(ServeiMudances.Operari sOp)
        {
            WP8_Operari wOp = new WP8_Operari();
            wOp.Id = sOp.Id;
            wOp.nom = sOp.nom;
            wOp.comentaris = sOp.comentaris;
            wOp.baixa = sOp.baixa;
            return wOp;
        }
        public static WP8_Client ServeiToWP8(ServeiMudances.Client sCli)
        {
            WP8_Client wCli = new WP8_Client();
            wCli.Id = sCli.Id;
            wCli.nom = sCli.nom;
            wCli.cognoms = sCli.cognoms;
            wCli.dni = sCli.dni;
            wCli.poblacio = sCli.poblacio;
            wCli.provincia = sCli.provincia;
            wCli.telefon = sCli.telefon;
            wCli.mobil = sCli.mobil;
            wCli.fax = sCli.fax;
            wCli.adreça = sCli.adreça;
            wCli.baixa = sCli.baixa;
            wCli.cp = sCli.cp;
            wCli.email = sCli.email;
            return wCli;
        }
        public static WP8_Imatge ServeiToWP8(ServeiMudances.LiniaPressupost sLin, ServeiMudances.Imatge sImg)
        {
            WP8_Imatge wImg = new WP8_Imatge();
            wImg.Id = sImg.Id;
            wImg.LiniaPressupost = sLin.Id;
            wImg.imatge = Convert.ToBase64String(sImg.imatge);
            return wImg;
        }
        public static WP8_LiniaPressupost ServeiToWP8(ServeiMudances.Pressupost wPre, ServeiMudances.LiniaPressupost sLin)
        {
            WP8_LiniaPressupost wLin = new WP8_LiniaPressupost();
            wLin.Id = sLin.Id;
            wLin.PressupostId = wPre.Id;
            wLin.article = sLin.article;
            wLin.comentaris = sLin.comentaris;
            wLin.transportat = sLin.transportat;
            wLin.temps_dedicat = sLin.temps_dedicat;
            wLin.preu = sLin.preu;
            return wLin;
        }
        public static WP8_Pressupost ServeiToWP8(ServeiMudances.Pressupost sPre, bool actualitzat)
        {
            WP8_Pressupost wPre = new WP8_Pressupost();
            wPre.Id = sPre.Id;
            wPre.data = sPre.data;
            wPre.acceptat = sPre.acceptat;
            wPre.facturat = sPre.facturat;
            wPre.num_factura = sPre.num_factura;
            wPre.adreça_origen = sPre.adreça_origen;
            wPre.adreça_desti = sPre.adreça_desti;
            wPre.cp_origen = sPre.cp_origen;
            wPre.cp_desti = sPre.cp_desti;
            wPre.poblacio_origen = sPre.poblacio_origen;
            wPre.poblacio_desti = sPre.poblacio_desti;
            wPre.provincia_origen = sPre.provincia_origen;
            wPre.provincia_desti = sPre.provincia_desti;

            wPre.UsuariId = sPre.usuari.Id;
            wPre.ClientId = sPre.client.Id;

            wPre.Actualitzat = actualitzat;

            return wPre;
        }
    }
}
